<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/quote-1.0.20/src/ext.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>ext.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../quote/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../quote/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../quote/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">super</span>::ToTokens</span>;

<span class="kw">use</span> <span class="ident">std::iter</span>;

<span class="kw">use</span> <span class="ident">proc_macro2</span>::{<span class="ident">TokenStream</span>, <span class="ident">TokenTree</span>};

<span class="doccomment">/// TokenStream extension trait with methods for appending tokens.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This trait is sealed and cannot be implemented outside of the `quote` crate.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">TokenStreamExt</span>: <span class="ident">private::Sealed</span> {
    <span class="doccomment">/// For use by `ToTokens` implementations.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Appends the token specified to this list of tokens.</span>
    <span class="kw">fn</span> <span class="ident">append</span><span class="op">&lt;</span><span class="ident">U</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">token</span>: <span class="ident">U</span>)
    <span class="kw">where</span>
        <span class="ident">U</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">TokenTree</span><span class="op">&gt;</span>;

    <span class="doccomment">/// For use by `ToTokens` implementations.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// # use quote::{quote, TokenStreamExt, ToTokens};</span>
    <span class="doccomment">/// # use proc_macro2::TokenStream;</span>
    <span class="doccomment">/// #</span>
    <span class="doccomment">/// struct X;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// impl ToTokens for X {</span>
    <span class="doccomment">///     fn to_tokens(&amp;self, tokens: &amp;mut TokenStream) {</span>
    <span class="doccomment">///         tokens.append_all(&amp;[true, false]);</span>
    <span class="doccomment">///     }</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let tokens = quote!(#X);</span>
    <span class="doccomment">/// assert_eq!(tokens.to_string(), &quot;true false&quot;);</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">fn</span> <span class="ident">append_all</span><span class="op">&lt;</span><span class="ident">I</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">iter</span>: <span class="ident">I</span>)
    <span class="kw">where</span>
        <span class="ident">I</span>: <span class="ident">IntoIterator</span>,
        <span class="ident">I::Item</span>: <span class="ident">ToTokens</span>;

    <span class="doccomment">/// For use by `ToTokens` implementations.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Appends all of the items in the iterator `I`, separated by the tokens</span>
    <span class="doccomment">/// `U`.</span>
    <span class="kw">fn</span> <span class="ident">append_separated</span><span class="op">&lt;</span><span class="ident">I</span>, <span class="ident">U</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">iter</span>: <span class="ident">I</span>, <span class="ident">op</span>: <span class="ident">U</span>)
    <span class="kw">where</span>
        <span class="ident">I</span>: <span class="ident">IntoIterator</span>,
        <span class="ident">I::Item</span>: <span class="ident">ToTokens</span>,
        <span class="ident">U</span>: <span class="ident">ToTokens</span>;

    <span class="doccomment">/// For use by `ToTokens` implementations.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Appends all tokens in the iterator `I`, appending `U` after each</span>
    <span class="doccomment">/// element, including after the last element of the iterator.</span>
    <span class="kw">fn</span> <span class="ident">append_terminated</span><span class="op">&lt;</span><span class="ident">I</span>, <span class="ident">U</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">iter</span>: <span class="ident">I</span>, <span class="ident">term</span>: <span class="ident">U</span>)
    <span class="kw">where</span>
        <span class="ident">I</span>: <span class="ident">IntoIterator</span>,
        <span class="ident">I::Item</span>: <span class="ident">ToTokens</span>,
        <span class="ident">U</span>: <span class="ident">ToTokens</span>;
}

<span class="kw">impl</span> <span class="ident">TokenStreamExt</span> <span class="kw">for</span> <span class="ident">TokenStream</span> {
    <span class="kw">fn</span> <span class="ident">append</span><span class="op">&lt;</span><span class="ident">U</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">token</span>: <span class="ident">U</span>)
    <span class="kw">where</span>
        <span class="ident">U</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">TokenTree</span><span class="op">&gt;</span>,
    {
        <span class="self">self</span>.<span class="ident">extend</span>(<span class="ident">iter::once</span>(<span class="ident">token</span>.<span class="ident">into</span>()));
    }

    <span class="kw">fn</span> <span class="ident">append_all</span><span class="op">&lt;</span><span class="ident">I</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">iter</span>: <span class="ident">I</span>)
    <span class="kw">where</span>
        <span class="ident">I</span>: <span class="ident">IntoIterator</span>,
        <span class="ident">I::Item</span>: <span class="ident">ToTokens</span>,
    {
        <span class="kw">for</span> <span class="ident">token</span> <span class="kw">in</span> <span class="ident">iter</span> {
            <span class="ident">token</span>.<span class="ident">to_tokens</span>(<span class="self">self</span>);
        }
    }

    <span class="kw">fn</span> <span class="ident">append_separated</span><span class="op">&lt;</span><span class="ident">I</span>, <span class="ident">U</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">iter</span>: <span class="ident">I</span>, <span class="ident">op</span>: <span class="ident">U</span>)
    <span class="kw">where</span>
        <span class="ident">I</span>: <span class="ident">IntoIterator</span>,
        <span class="ident">I::Item</span>: <span class="ident">ToTokens</span>,
        <span class="ident">U</span>: <span class="ident">ToTokens</span>,
    {
        <span class="kw">for</span> (<span class="ident">i</span>, <span class="ident">token</span>) <span class="kw">in</span> <span class="ident">iter</span>.<span class="ident">into_iter</span>().<span class="ident">enumerate</span>() {
            <span class="kw">if</span> <span class="ident">i</span> <span class="op">&gt;</span> <span class="number">0</span> {
                <span class="ident">op</span>.<span class="ident">to_tokens</span>(<span class="self">self</span>);
            }
            <span class="ident">token</span>.<span class="ident">to_tokens</span>(<span class="self">self</span>);
        }
    }

    <span class="kw">fn</span> <span class="ident">append_terminated</span><span class="op">&lt;</span><span class="ident">I</span>, <span class="ident">U</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">iter</span>: <span class="ident">I</span>, <span class="ident">term</span>: <span class="ident">U</span>)
    <span class="kw">where</span>
        <span class="ident">I</span>: <span class="ident">IntoIterator</span>,
        <span class="ident">I::Item</span>: <span class="ident">ToTokens</span>,
        <span class="ident">U</span>: <span class="ident">ToTokens</span>,
    {
        <span class="kw">for</span> <span class="ident">token</span> <span class="kw">in</span> <span class="ident">iter</span> {
            <span class="ident">token</span>.<span class="ident">to_tokens</span>(<span class="self">self</span>);
            <span class="ident">term</span>.<span class="ident">to_tokens</span>(<span class="self">self</span>);
        }
    }
}

<span class="kw">mod</span> <span class="ident">private</span> {
    <span class="kw">use</span> <span class="ident">proc_macro2::TokenStream</span>;

    <span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Sealed</span> {}

    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="ident">TokenStream</span> {}
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="quote" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>